"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var fs = require("fs");
var promises_1 = require("fs/promises");
var path = require("path");
var tar = require("tar");
var binaries_1 = require("./binaries");
function download(url, dest) {
    return __awaiter(this, void 0, void 0, function () {
        var file;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    file = fs.createWriteStream(dest);
                    /* Using Promises so that we can use the ASYNC AWAIT syntax */
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            request({
                                /* Here you should specify the exact link to the file you are trying to download */
                                uri: url,
                                gzip: true,
                            })
                                .pipe(file)
                                .on('finish', function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    console.log(dest + " is finished downloading.");
                                    resolve();
                                    return [2 /*return*/];
                                });
                            }); })
                                .on('error', function (error) {
                                reject(error);
                            });
                        }).catch(function (error) {
                            console.log("Something happened: " + error);
                        })];
                case 1:
                    /* Using Promises so that we can use the ASYNC AWAIT syntax */
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function downloadBinaries(tag) {
    return __awaiter(this, void 0, void 0, function () {
        var holochainRunnerFilenames, lairKeystoreFilenames, lairKeystoreUrl, holochainRunnerCompressedUrl, compressedTempFilename;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fs.rmSync(binaries_1.binariesDirectory, { recursive: true, force: true });
                    fs.mkdirSync(binaries_1.binariesDirectory);
                    holochainRunnerFilenames = {
                        win32: 'holochain-runner-x86_64-pc-windows-msvc.tar.gz',
                        darwin: 'holochain-runner-x86_64-apple-darwin.tar.gz',
                        linux: 'holochain-runner-x86_64-unknown-linux-gnu.tar.gz'
                    };
                    lairKeystoreFilenames = {
                        win32: 'lair-keystore-x86_64-pc-windows-msvc.exe',
                        darwin: 'lair-keystore-x86_64-apple-darwin',
                        linux: 'lair-keystore-x86_64-unknown-linux-gnu'
                    };
                    lairKeystoreUrl = "https://github.com/Sprillow/holochain-runner/releases/download/" + tag + "/" + lairKeystoreFilenames[process.platform];
                    return [4 /*yield*/, download(lairKeystoreUrl, binaries_1.defaultLairKeystoreBinaryPath)];
                case 1:
                    _a.sent();
                    holochainRunnerCompressedUrl = "https://github.com/Sprillow/holochain-runner/releases/download/" + tag + "/" + holochainRunnerFilenames[process.platform];
                    compressedTempFilename = path.join(binaries_1.binariesDirectory, holochainRunnerFilenames[process.platform]);
                    return [4 /*yield*/, download(holochainRunnerCompressedUrl, compressedTempFilename)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, tar.x({ file: compressedTempFilename, cwd: binaries_1.binariesDirectory })];
                case 3:
                    _a.sent();
                    fs.rmSync(compressedTempFilename);
                    // defaultHolochainRunnerBinaryPath
                    return [4 /*yield*/, promises_1.chmod(binaries_1.defaultLairKeystoreBinaryPath, 511)];
                case 4:
                    // defaultHolochainRunnerBinaryPath
                    _a.sent();
                    return [4 /*yield*/, promises_1.chmod(binaries_1.defaultHolochainRunnerBinaryPath, 511)];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
;
(function () { return __awaiter(void 0, void 0, void 0, function () {
    var holochainRunnerTag, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                holochainRunnerTag = 'v0.0.36';
                return [4 /*yield*/, downloadBinaries(holochainRunnerTag)];
            case 1:
                _a.sent();
                return [3 /*break*/, 3];
            case 2:
                e_1 = _a.sent();
                console.log(e_1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); })();
//# sourceMappingURL=downloadBinaries.js.map