"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runHolochain = exports.StateSignal = exports.StatusUpdates = exports.HOLOCHAIN_RUNNER_QUIT = exports.LAIR_KEYSTORE_QUIT = exports.ERROR_EVENT = exports.APP_PORT_EVENT = exports.STATUS_EVENT = void 0;
var childProcess = require("child_process");
var events_1 = require("events");
// eslint-disable-next-line @typescript-eslint/ban-ts-ignore
// @ts-ignore
var split = require("split");
var options_1 = require("./options");
var binaries_1 = require("./binaries");
var STATUS_EVENT = 'status';
exports.STATUS_EVENT = STATUS_EVENT;
var APP_PORT_EVENT = 'port';
exports.APP_PORT_EVENT = APP_PORT_EVENT;
var ERROR_EVENT = 'error';
exports.ERROR_EVENT = ERROR_EVENT;
var HOLOCHAIN_RUNNER_QUIT = 'holochain_runner_quit';
exports.HOLOCHAIN_RUNNER_QUIT = HOLOCHAIN_RUNNER_QUIT;
var LAIR_KEYSTORE_QUIT = 'lair_keystore_quit';
exports.LAIR_KEYSTORE_QUIT = LAIR_KEYSTORE_QUIT;
var StatusUpdates = /** @class */ (function (_super) {
    __extends(StatusUpdates, _super);
    function StatusUpdates() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StatusUpdates.prototype.emitStatus = function (status) {
        this.emit(STATUS_EVENT, status);
    };
    StatusUpdates.prototype.emitAppPort = function (port) {
        this.emit(APP_PORT_EVENT, port);
    };
    StatusUpdates.prototype.emitError = function (error) {
        this.emit(ERROR_EVENT, error);
    };
    StatusUpdates.prototype.emitHolochainRunnerQuit = function () {
        this.emit(HOLOCHAIN_RUNNER_QUIT);
    };
    StatusUpdates.prototype.emitLairKeystoreQuit = function () {
        this.emit(LAIR_KEYSTORE_QUIT);
    };
    return StatusUpdates;
}(events_1.EventEmitter));
exports.StatusUpdates = StatusUpdates;
var StateSignal;
(function (StateSignal) {
    StateSignal[StateSignal["IsFirstRun"] = 0] = "IsFirstRun";
    StateSignal[StateSignal["IsNotFirstRun"] = 1] = "IsNotFirstRun";
    StateSignal[StateSignal["CreatingKeys"] = 2] = "CreatingKeys";
    StateSignal[StateSignal["RegisteringDna"] = 3] = "RegisteringDna";
    StateSignal[StateSignal["InstallingApp"] = 4] = "InstallingApp";
    StateSignal[StateSignal["EnablingApp"] = 5] = "EnablingApp";
    StateSignal[StateSignal["AddingAppInterface"] = 6] = "AddingAppInterface";
    StateSignal[StateSignal["IsReady"] = 7] = "IsReady";
})(StateSignal = exports.StateSignal || (exports.StateSignal = {}));
function stdoutToStateSignal(string) {
    switch (string) {
        case '0':
            return StateSignal.IsFirstRun;
        case '1':
            return StateSignal.IsNotFirstRun;
        // IsFirstRun events
        case '2':
            return StateSignal.CreatingKeys;
        case '3':
            return StateSignal.RegisteringDna;
        case '4':
            return StateSignal.InstallingApp;
        case '5':
            return StateSignal.EnablingApp;
        case '6':
            return StateSignal.AddingAppInterface;
        // Done/Ready Event
        case '7':
            return StateSignal.IsReady;
        default:
            return null;
    }
}
function runHolochain(statusEmitter, options, pathOptions) {
    return __awaiter(this, void 0, void 0, function () {
        var lairKeystoreBinaryPath, holochainRunnerBinaryPath, lairHandle, optionsArray, holochainRunnerHandle;
        return __generator(this, function (_a) {
            lairKeystoreBinaryPath = pathOptions
                ? pathOptions.lairKeystoreBinaryPath
                : binaries_1.defaultLairKeystoreBinaryPath;
            holochainRunnerBinaryPath = pathOptions
                ? pathOptions.holochainRunnerBinaryPath
                : binaries_1.defaultHolochainRunnerBinaryPath;
            lairHandle = childProcess.spawn(lairKeystoreBinaryPath, [
                '--lair-dir',
                options.keystorePath,
            ]);
            lairHandle.stdout.on('error', function (error) {
                console.error('lair-keystore stdout err > ' + error);
                statusEmitter.emitError(error);
            });
            lairHandle.stderr.on('data', function (error) {
                console.error('lair-keystore stderr err' + error.toString());
                statusEmitter.emitError(error);
            });
            lairHandle.on('error', function (error) {
                console.error('lair-keystore err > ' + error.toString());
                statusEmitter.emitError(error);
            });
            lairHandle.on('close', function (code) {
                console.log('lair-keystore closed with code: ', code);
                statusEmitter.emitLairKeystoreQuit();
            });
            optionsArray = options_1.constructOptions(options);
            holochainRunnerHandle = childProcess.spawn(holochainRunnerBinaryPath, optionsArray);
            // split divides up the stream line by line
            holochainRunnerHandle.stdout.pipe(split()).on('data', function (line) {
                console.debug('holochain > ' + line);
                // Check for state signal
                var checkIfSignal = stdoutToStateSignal(line);
                if (checkIfSignal !== null) {
                    statusEmitter.emitStatus(checkIfSignal);
                }
                // Check for app port
                var appPort = parseForAppPort(line);
                if (appPort !== null) {
                    statusEmitter.emitAppPort(appPort);
                }
            });
            holochainRunnerHandle.stdout.on('error', function (error) {
                console.error('holochain stdout err > ' + error);
                statusEmitter.emitError(error);
            });
            holochainRunnerHandle.stderr.on('data', function (error) {
                console.error('holochain stderr err > ' + error.toString());
                statusEmitter.emitError(new Error(error.toString()));
            });
            holochainRunnerHandle.on('error', function (error) {
                console.error('holochain err > ' + error.toString());
                statusEmitter.emitError(error);
            });
            holochainRunnerHandle.on('close', function (code) {
                console.log('holochain-runner closed with code: ', code);
                statusEmitter.emitHolochainRunnerQuit();
            });
            return [2 /*return*/, {
                    lairHandle: lairHandle,
                    holochainRunnerHandle: holochainRunnerHandle,
                }];
        });
    });
}
exports.runHolochain = runHolochain;
function parseForAppPort(line) {
    var regex = /APP_WS_PORT: ([0-9]*)/gm;
    var match = regex.exec(line);
    // console.log({match});
    if (match === undefined || match === null || match.length === 0) {
        return null;
    }
    return match[1];
}
//# sourceMappingURL=holochain.js.map