"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLairVersion = exports.getRunnerVersion = exports.HOLOCHAIN_RUNNER_QUIT = exports.LAIR_KEYSTORE_QUIT = exports.ERROR_EVENT = exports.APP_PORT_EVENT = exports.STATUS_EVENT = exports.StatusUpdates = exports.StateSignal = void 0;
var holochain_1 = require("./holochain");
Object.defineProperty(exports, "StateSignal", { enumerable: true, get: function () { return holochain_1.StateSignal; } });
Object.defineProperty(exports, "StatusUpdates", { enumerable: true, get: function () { return holochain_1.StatusUpdates; } });
Object.defineProperty(exports, "STATUS_EVENT", { enumerable: true, get: function () { return holochain_1.STATUS_EVENT; } });
Object.defineProperty(exports, "APP_PORT_EVENT", { enumerable: true, get: function () { return holochain_1.APP_PORT_EVENT; } });
Object.defineProperty(exports, "ERROR_EVENT", { enumerable: true, get: function () { return holochain_1.ERROR_EVENT; } });
Object.defineProperty(exports, "LAIR_KEYSTORE_QUIT", { enumerable: true, get: function () { return holochain_1.LAIR_KEYSTORE_QUIT; } });
Object.defineProperty(exports, "HOLOCHAIN_RUNNER_QUIT", { enumerable: true, get: function () { return holochain_1.HOLOCHAIN_RUNNER_QUIT; } });
var binaries_1 = require("./binaries");
var childProcess = require("child_process");
var fs = require("fs");
var kill = require("tree-kill");
// start up lair and holochain-runner processes,
// automatically shut them down on app quit,
// and emit events for status updates on their installation progress
function initAgent(app, opts, binaryPaths) {
    return __awaiter(this, void 0, void 0, function () {
        var statusEmitter, lairHandle, holochainRunnerHandle;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // wait for the app to be ready
                return [4 /*yield*/, app.whenReady()];
                case 1:
                    // wait for the app to be ready
                    _a.sent();
                    statusEmitter = new holochain_1.StatusUpdates();
                    (function () { return __awaiter(_this, void 0, void 0, function () {
                        var handles;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, holochain_1.runHolochain(statusEmitter, opts, binaryPaths)];
                                case 1:
                                    handles = _a.sent();
                                    lairHandle = handles.lairHandle;
                                    holochainRunnerHandle = handles.holochainRunnerHandle;
                                    app.on('will-quit', function () { return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: 
                                                // SIGTERM signal is the default, and that's good
                                                return [4 /*yield*/, killHolochain(lairHandle, holochainRunnerHandle)];
                                                case 1:
                                                    // SIGTERM signal is the default, and that's good
                                                    _a.sent();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); });
                                    return [2 /*return*/];
                            }
                        });
                    }); })();
                    return [2 /*return*/, {
                            statusEmitter: statusEmitter,
                            shutdown: function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: 
                                        // SIGTERM signal is the default, and that's good
                                        return [4 /*yield*/, killHolochain(lairHandle, holochainRunnerHandle)];
                                        case 1:
                                            // SIGTERM signal is the default, and that's good
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); },
                        }];
            }
        });
    });
}
exports.default = initAgent;
/**
 *
 */
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
/**
 * Kill handles and their children
 */
function killHolochain(lairHandle, holochainRunnerHandle) {
    return __awaiter(this, void 0, void 0, function () {
        var canWaitForHolochain, canWaitForKeystore, start_time;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    canWaitForHolochain = false;
                    if (holochainRunnerHandle && holochainRunnerHandle.pid) {
                        canWaitForHolochain = true;
                        console.debug('Killing holochain sub processes...');
                        kill(holochainRunnerHandle.pid, function (err) {
                            canWaitForHolochain = false;
                            if (!err) {
                                console.debug('killed all holochain sub processes');
                            }
                            else {
                                console.error(err);
                            }
                        });
                    }
                    canWaitForKeystore = false;
                    if (lairHandle && lairHandle.pid) {
                        canWaitForKeystore = true;
                        console.debug('Killing lair-keystore sub processes...');
                        kill(lairHandle.pid, function (err) {
                            canWaitForKeystore = false;
                            if (!err) {
                                console.debug('killed all lair-keystore sub processes');
                            }
                            else {
                                console.error(err);
                            }
                        });
                    }
                    // Wait for the kill commands to complete and exit anyway after a timeout
                    console.debug('waiting...');
                    start_time = Date.now();
                    _a.label = 1;
                case 1:
                    if (!(canWaitForHolochain || canWaitForKeystore)) return [3 /*break*/, 3];
                    return [4 /*yield*/, sleep(10)];
                case 2:
                    _a.sent();
                    if (Date.now() - start_time > 5 * 1000) {
                        console.error('Killing sub-processes TIMED-OUT. Aborted.');
                        return [3 /*break*/, 3];
                    }
                    return [3 /*break*/, 1];
                case 3:
                    console.debug('Killing sub-processes DONE.');
                    return [2 /*return*/];
            }
        });
    });
}
/**
 *
 */
function getRunnerVersion(runnerBinaryPath) {
    var holochainRunnerBinaryPath = runnerBinaryPath
        ? runnerBinaryPath
        : binaries_1.defaultHolochainRunnerBinaryPath;
    if (!fs.existsSync(holochainRunnerBinaryPath)) {
        console.error('holochain-runner binary not found at path: ' + holochainRunnerBinaryPath);
        return 'holochain-runner missing';
    }
    var holochainHandle = childProcess.spawnSync(holochainRunnerBinaryPath, [
        '--version',
    ]);
    if (holochainHandle.error) {
        console.error('Calling holochain-runner failed: ' + holochainHandle.error.message);
        return 'holochain-runner broken';
    }
    return holochainHandle.stdout.toString();
}
exports.getRunnerVersion = getRunnerVersion;
/**
 *
 */
function getLairVersion(lairBinaryPath) {
    var binaryPath = lairBinaryPath
        ? lairBinaryPath
        : binaries_1.defaultLairKeystoreBinaryPath;
    if (!fs.existsSync(binaryPath)) {
        console.error('lair-keystore binary not found at path: ' + binaryPath);
        return 'lair-keystore missing';
    }
    var handle = childProcess.spawnSync(binaryPath, ['--version']);
    if (handle.error) {
        console.error('Calling lair-keystore failed: ' + handle.error.message);
        return 'lair-keystore broken';
    }
    return handle.stdout.toString();
}
exports.getLairVersion = getLairVersion;
//# sourceMappingURL=index.js.map