"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.constructOptions = void 0;
// translate the options object into
// an array of arguments that get passed to a ChildProcess exec call
// for the holochain-runner binary
function constructOptions(options) {
    var optionsArr = [];
    if (options.appId) {
        optionsArr = optionsArr.concat(['--app-id', options.appId]);
    }
    if (options.appWsPort) {
        optionsArr = optionsArr.concat([
            '--app-ws-port',
            options.appWsPort.toString(),
        ]);
    }
    if (options.adminWsPort) {
        optionsArr = optionsArr.concat([
            '--admin-ws-port',
            options.adminWsPort.toString(),
        ]);
    }
    if (options.keystorePath) {
        optionsArr = optionsArr.concat(['--keystore-path', options.keystorePath]);
    }
    if (options.proxyUrl) {
        optionsArr = optionsArr.concat(['--proxy-url', options.proxyUrl]);
    }
    // if (options.membraneProof) {
    //   optionsArr = optionsArr.concat(['--membrane-proof', options.membraneProof])
    // }
    if (options.bootstrapUrl) {
        optionsArr = optionsArr.concat(['--bootstrap-url', options.bootstrapUrl]);
    }
    if (options.uid) {
        optionsArr = optionsArr.concat(['--uid', options.uid]);
    }
    // dnaPath is required
    optionsArr = optionsArr.concat([options.happPath]);
    if (options.datastorePath) {
        optionsArr = optionsArr.concat([options.datastorePath]);
    }
    return optionsArr;
}
exports.constructOptions = constructOptions;
//# sourceMappingURL=options.js.map